%bcond_without check

%global crate pleaser

Name:           rust-pleaser
Version:        0.5.4
Release:    1%{?dist}
Summary:        Please, a polite regex-first sudo alternative

License:        GPL-3.0-or-later
URL:            https://crates.io/crates/pleaser
Source0:         %{crates_source}
Patch:          pleaser-fix-metadata.diff

BuildRequires:  rust-packaging >= 23

%global _description %{expand:
Please, a polite regex-first sudo alternative.}

%description %{_description}

%package     -n %{crate}
Summary:        %{summary}
License:        GPL-3.0-or-later AND Apache-2.0 AND MIT AND Unicode-DFS-2016

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE
%license LICENSE.dependencies
%doc CHANGELOG.md
%doc CONTRIBUTING.md
%doc README.md
%doc please.ini.md
%doc please.md
%{_bindir}/please
%{_bindir}/pleaseedit
%{_mandir}/man1/please.1*
%{_mandir}/man5/please.ini.5*
%config(noreplace) /etc/pam.d/please
%config(noreplace) /etc/pam.d/pleaseedit
%{bash_completions_dir}/please
%zsh_completions_dir/_please

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages which
use the "%{crate}" crate.

%files          devel
%license %{crate_instdir}/LICENSE
%doc %{crate_instdir}/CHANGELOG.md
%doc %{crate_instdir}/CONTRIBUTING.md
%doc %{crate_instdir}/README.md
%doc %{crate_instdir}/please.ini.md
%doc %{crate_instdir}/please.md
%{crate_instdir}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages which
use the "default" feature of the "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{crate_instdir}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version} -p1
%cargo_prep

%generate_buildrequires
%cargo_generate_buildrequires

%build
%cargo_build
%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies

%install
%cargo_install
%{__install} -Dpm4755 -t %{buildroot}%{_bindir} target/release/please
%{__install} -Dpm4755 -t %{buildroot}%{_bindir} target/release/pleaseedit
%{__install} -Dpm0644 -t %{buildroot}%{_mandir}/man1 man/please.1
%{__install} -Dpm0644 -t %{buildroot}%{_mandir}/man5 man/please.ini.5
%{__install} -Dpm0644 -t %{buildroot}%{bash_completions_dir} completions/bash/please
%{__install} -Dpm0644 -t %{buildroot}%{zsh_completions_dir} completions/zsh/_please

mkdir -p %{buildroot}/etc/pam.d
cat > %{buildroot}/etc/pam.d/please << EOF
auth       include      system-auth
account    include      system-auth
password   include      system-auth
session    optional     pam_keyinit.so revoke
session    required     pam_limits.so
session    include      system-auth
EOF

mkdir -p %{buildroot}/etc/pam.d
cat > %{buildroot}/etc/pam.d/pleaseedit << EOF
auth       include      system-auth
account    include      system-auth
password   include      system-auth
session    optional     pam_keyinit.so revoke
session    required     pam_limits.so
session    include      system-auth
EOF

%if %{with check}
%check
%cargo_test -- --tests -- --skip test::test_search_bin_default_sbin
%endif

%changelog
* Tue Jun 18 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.5.4-1
- initial build
